VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   5295
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   5295
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lstPeople 
      Height          =   450
      ItemData        =   "Form1.frx":0000
      Left            =   0
      List            =   "Form1.frx":0002
      TabIndex        =   1
      Top             =   0
      Width           =   1935
   End
   Begin VB.PictureBox picPerson 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   3015
      Left            =   2040
      ScaleHeight     =   3015
      ScaleWidth      =   3135
      TabIndex        =   0
      Top             =   0
      Visible         =   0   'False
      Width           =   3135
   End
   Begin MSComDlg.CommonDialog dlgPicture 
      Left            =   240
      Top             =   1920
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu mnuRecord 
      Caption         =   "&Record"
      Begin VB.Menu mnuRecordAdd 
         Caption         =   "Add"
         Shortcut        =   ^A
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' DB stuff.
Private m_DBConn As ADODB.Connection
Private Const BLOCK_SIZE = 10000

' DIB stuff.
Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Private Declare Function SetDIBits Lib "gdi32" (ByVal hdc As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Private Type BITMAP '14 bytes
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type
Private Type BITMAPINFOHEADER '40 bytes
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type
Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type
Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors As RGBQUAD
End Type
Private Const DIB_RGB_COLORS = 0&
Private Const BI_RGB = 0&

Private Const pixR As Integer = 3
Private Const pixG As Integer = 2
Private Const pixB As Integer = 1

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

' Save the picture into the database as a DIB.
Private Sub SaveDibToDb(rs As ADODB.Recordset)
Dim bytes_per_scanLine As Integer
Dim wid As Long
Dim hgt As Long
Dim bitmap_info As BITMAPINFO
Dim pixels() As Byte
Dim buffer() As Byte

    ' Prepare the bitmap description.
    wid = picPerson.ScaleWidth
    hgt = picPerson.ScaleHeight
    With bitmap_info.bmiHeader
        .biSize = 40
        .biWidth = wid
        ' Use negative height to scan top-down.
        .biHeight = -hgt
        .biPlanes = 1
        .biBitCount = 32
        .biCompression = BI_RGB
        bytes_per_scanLine = ((((.biWidth * .biBitCount) + 31) \ 32) * 4)
        .biSizeImage = bytes_per_scanLine * hgt
    End With

    ' Load the bitmap's data.
    ReDim pixels(1 To 4, 1 To wid, 1 To hgt)
    GetDIBits picPerson.hdc, picPerson.Image, _
        0, hgt, pixels(1, 1, 1), _
        bitmap_info, DIB_RGB_COLORS

    ' Save the BITMAPINFO.
    ReDim buffer(0 To Len(bitmap_info.bmiHeader) - 1)
    CopyMemory buffer(0), bitmap_info.bmiHeader, Len(bitmap_info.bmiHeader)

    rs!Picture.AppendChunk buffer

    ' Save the pixels.
    ReDim buffer(0 To 4 * wid * hgt - 1)
    CopyMemory buffer(0), pixels(1, 1, 1), 4 * wid * hgt
    rs!Picture.AppendChunk buffer
End Sub
' Load the DIB from the database.
Private Sub LoadDibFromDb(rs As ADODB.Recordset)
Dim bytes_per_scanLine As Integer
Dim wid As Long
Dim hgt As Long
Dim bitmap_info As BITMAPINFO
Dim pixels() As Byte
Dim buffer() As Byte

    ' Get the BITMAPINFO.
    buffer = rs!Picture.GetChunk(Len(bitmap_info.bmiHeader))
    CopyMemory bitmap_info.bmiHeader, buffer(0), Len(bitmap_info.bmiHeader)

    ' Get the pixels.
    wid = bitmap_info.bmiHeader.biWidth
    hgt = Abs(bitmap_info.bmiHeader.biHeight)
    buffer = rs!Picture.GetChunk(4 * wid * hgt)

    ReDim pixels(1 To 4, 1 To wid, 1 To hgt)
    CopyMemory pixels(1, 1, 1), buffer(0), 4 * wid * hgt

    ' Size the PictureBox.
    picPerson.Move picPerson.Left, picPerson.Top, wid, hgt

    ' Display the results.
    SetDIBits picPerson.hdc, picPerson.Image, _
        0, hgt, pixels(1, 1, 1), _
        bitmap_info, DIB_RGB_COLORS
    picPerson.Picture = picPerson.Image
End Sub
Private Sub Form_Load()
Dim db_file As String
Dim rs As ADODB.Recordset

    ' Prepare the PictureBox.
    ScaleMode = vbPixels
    picPerson.ScaleMode = vbPixels
    picPerson.AutoRedraw = True

    ' Get the database file name.
    db_file = App.Path
    If Right$(db_file, 1) <> "\" Then db_file = db_file & "\"
    db_file = db_file & "dbpict.mdb"

    ' Open the database connection.
    Set m_DBConn = New ADODB.Connection
    m_DBConn.Open _
        "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Data Source=" & db_file & ";" & _
        "Persist Security Info=False"

    ' Get the list of people.
    Set rs = m_DBConn.Execute("SELECT Name FROM People ORDER BY Name", , adCmdText)
    Do While Not rs.EOF
        lstPeople.AddItem rs!Name
        rs.MoveNext
    Loop

    rs.Close
    Set rs = Nothing
End Sub
Private Sub Form_Resize()
    lstPeople.Height = ScaleHeight
End Sub


' Display the clicked person.
Private Sub lstPeople_Click()
Dim rs As ADODB.Recordset
Dim hgt As Single

    picPerson.Visible = False
    Screen.MousePointer = vbHourglass
    DoEvents

    ' Get the record.
    Set rs = m_DBConn.Execute("SELECT * FROM People WHERE Name='" & _
        lstPeople.Text & "'", , adCmdText)
    If rs.EOF Then Exit Sub

    ' Load the picture.
    LoadDibFromDb rs

    ' Display the picture file.
    picPerson.Visible = True

    Width = Width + ScaleX(picPerson.Left + picPerson.Width - ScaleWidth, ScaleMode, vbTwips)
    hgt = Height + ScaleY(picPerson.Top + picPerson.Height - ScaleHeight, ScaleMode, vbTwips)
    If hgt < 1440 Then hgt = 1440
    Height = hgt

    Screen.MousePointer = vbDefault
End Sub

Private Sub mnuRecordAdd_Click()
Dim rs As ADODB.Recordset
Dim person_name As String

    person_name = InputBox("Name")
    If Len(person_name) = 0 Then Exit Sub

    dlgPicture.Flags = _
        cdlOFNFileMustExist Or _
        cdlOFNHideReadOnly Or _
        cdlOFNExplorer
    dlgPicture.CancelError = True
    dlgPicture.Filter = "Graphics Files|*.bmp;*.ico;*.jpg;*.gif"

    On Error Resume Next
    dlgPicture.ShowOpen
    If Err.Number = cdlCancel Then
        Exit Sub
    ElseIf Err.Number <> 0 Then
        MsgBox "Error " & Format$(Err.Number) & _
            " selecting file." & vbCrLf & Err.Description
        Exit Sub
    End If
    On Error GoTo 0

    ' Load the picture.
    picPerson.Picture = LoadPicture(dlgPicture.FileName)

    Set rs = New ADODB.Recordset
    rs.CursorType = adOpenKeyset
    rs.LockType = adLockOptimistic
    rs.Open "Select Name, Picture FROM People", m_DBConn

    rs.AddNew
    rs!Name = person_name

    ' Save the picture.
    SaveDibToDb rs

    rs.Update

    lstPeople.AddItem person_name
    lstPeople.Text = person_name
End Sub
